package com.ruoyi.web.controller.agentcenter;

import com.ruoyi.agentcenter.domain.TAgentTask;
import com.ruoyi.agentcenter.service.ITAgentTaskService;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.utils.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.List;

/**
 * 任务清单Controller
 * 
 * @author zhao
 * @date 2023-05-06
 */
@RestController
@RequestMapping("/accounting/task")
public class AccountingAgentTaskController extends BaseController
{
    @Autowired
    private ITAgentTaskService tAgentTaskService;

    /**
     * 获取任务清单列表(按镇村分组)
     */
    @PreAuthorize("@ss.hasPermi('agentcenter:task:list')")
    @GetMapping(value = "/todoTaskList")
    public TableDataInfo todoTaskList(TAgentTask task)
    {
        startPage();
        PageUtils.orderBy("org_code");
        task.putParam("agentStatusList", Arrays.asList(TAgentTask.AGENT_STATUS_READY, TAgentTask.AGENT_STATUS_PROCESSING));
        List<TAgentTask> tAgentTasks = tAgentTaskService.selectTAgentTaskList(task);
        tAgentTasks.forEach((x) -> {
            x.setOtherCount(x.getAllCount() - x.getContracCount() - x.getVoucherCount());
        });
        return getDataTable(tAgentTasks);
    }
}
